org.apache.commons.io.input

## Class CharSequenceInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.commons.io.input.CharSequenceInputStream

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public class CharSequenceInputStream
      extends InputStream

  Implements an `InputStream` to read bytes from String, StringBuffer, StringBuilder or CharBuffer, encoded using the specified Charset. The Charset defaults to Charset.defaultCharset().

  Note: Supports `mark(int)` and `reset()`.

  To build an instance, use `CharSequenceInputStream.Builder`.

  See Also:
    `CharSequenceInputStream.Builder`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `CharSequenceInputStream.Builder` Builds a new `CharSequenceInputStream`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Gets a lower bound on the number of bytes remaining in the byte stream.
    `static CharSequenceInputStream.Builder` | `builder()` Constructs a new `CharSequenceInputStream.Builder`.
    `void` | `close()`
    `(package private) CharsetEncoder` | `getCharsetEncoder()` Gets the CharsetEncoder.
    `void` | `mark(int readLimit)`
    `boolean` | `markSupported()`
    `int` | `read()`
    `int` | `read(byte[] b)`
    `int` | `read(byte[] array, int off, int len)`
    `void` | `reset()`
    `long` | `skip(long n)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### available

          public int available()
                        throws IOException

      Gets a lower bound on the number of bytes remaining in the byte stream.
      Overrides:
        `available` in class `InputStream`
      Returns:
        the count of bytes that can be read without blocking (or returning EOF).
      Throws:
        `IOException` - if an error occurs (probably not possible).

    - #### builder

          public static CharSequenceInputStream.Builder builder()

      Constructs a new `CharSequenceInputStream.Builder`.
      Returns:
        a new `CharSequenceInputStream.Builder`.

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `InputStream`
      Throws:
        `IOException`

    - #### getCharsetEncoder

          CharsetEncoder getCharsetEncoder()

      Gets the CharsetEncoder.
      Returns:
        the CharsetEncoder.

    - #### mark

          public void mark(int readLimit)

      Overrides:
        `mark` in class `InputStream`
      Parameters:
        `readLimit` - max read limit (ignored).

    - #### markSupported

          public boolean markSupported()

      Overrides:
        `markSupported` in class `InputStream`

    - #### read

          public int read()
                   throws IOException

      Specified by:
        `read` in class `InputStream`
      Throws:
        `IOException`

    - #### read

          public int read(byte[] b)
                   throws IOException

      Overrides:
        `read` in class `InputStream`
      Throws:
        `IOException`

    - #### read

          public int read(byte[] array,
                          int off,
                          int len)
                   throws IOException

      Overrides:
        `read` in class `InputStream`
      Throws:
        `IOException`

    - #### reset

          public void reset()
                     throws IOException

      Overrides:
        `reset` in class `InputStream`
      Throws:
        `IOException`

    - #### skip

          public long skip(long n)
                    throws IOException

      Overrides:
        `skip` in class `InputStream`
      Throws:
        `IOException`